/*----- PROTECTED REGION ID(HdbConfigurationManagerClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: HdbConfigurationManagerClass.cpp,v 1.2 2014-03-07 14:04:20 graziano Exp $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/hdb++/hdb++cm/src/HdbConfigurationManagerClass.cpp,v $";
static const char *SvnPath    = "$HeadURL$";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        HdbConfigurationManagerClass.cpp
//
// description : C++ source for the HdbConfigurationManagerClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the HdbConfigurationManager once per process.
//
// project :     Hdb++ configuration manager
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: graziano $
//
// $Revision: 1.2 $
// $Date: 2014-03-07 14:04:20 $
//
// $HeadURL$
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <HdbConfigurationManagerClass.h>

/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass.cpp

//-------------------------------------------------------------------
/**
 *	Create HdbConfigurationManagerClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_HdbConfigurationManager_class(const char *name) {
		return HdbConfigurationManager_ns::HdbConfigurationManagerClass::init(name);
	}
}

namespace HdbConfigurationManager_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
HdbConfigurationManagerClass *HdbConfigurationManagerClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		HdbConfigurationManagerClass::HdbConfigurationManagerClass(std::string &s)
 * description : 	constructor for the HdbConfigurationManagerClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
HdbConfigurationManagerClass::HdbConfigurationManagerClass(std::string &s):Tango::DeviceClass(s)
{
	TANGO_LOG_INFO << "Entering HdbConfigurationManagerClass constructor" << std::endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::constructor

	TANGO_LOG_INFO << "Leaving HdbConfigurationManagerClass constructor" << std::endl;
}

//--------------------------------------------------------
/**
 * method : 		HdbConfigurationManagerClass::~HdbConfigurationManagerClass()
 * description : 	destructor for the HdbConfigurationManagerClass
 */
//--------------------------------------------------------
HdbConfigurationManagerClass::~HdbConfigurationManagerClass()
{
	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		HdbConfigurationManagerClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
HdbConfigurationManagerClass *HdbConfigurationManagerClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			std::string s(name);
			_instance = new HdbConfigurationManagerClass(s);
		}
		catch (std::bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		HdbConfigurationManagerClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
HdbConfigurationManagerClass *HdbConfigurationManagerClass::instance()
{
	if (_instance == NULL)
	{
            std::cerr << "Class is not initialised !!" << std::endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		AttributeAddClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AttributeAddClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "AttributeAddClass::execute(): arrived" << std::endl;
	((static_cast<HdbConfigurationManager *>(device))->attribute_add());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AttributeRemoveClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AttributeRemoveClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "AttributeRemoveClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	((static_cast<HdbConfigurationManager *>(device))->attribute_remove(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AttributeStartClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AttributeStartClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "AttributeStartClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	((static_cast<HdbConfigurationManager *>(device))->attribute_start(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AttributeStopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AttributeStopClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "AttributeStopClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	((static_cast<HdbConfigurationManager *>(device))->attribute_stop(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ArchiverAddClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ArchiverAddClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "ArchiverAddClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	((static_cast<HdbConfigurationManager *>(device))->archiver_add(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AttributeAssignClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AttributeAssignClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "AttributeAssignClass::execute(): arrived" << std::endl;
	const Tango::DevVarStringArray *argin;
	extract(in_any, argin);
	((static_cast<HdbConfigurationManager *>(device))->attribute_assign(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AttributeStatusClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AttributeStatusClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "AttributeStatusClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	return insert((static_cast<HdbConfigurationManager *>(device))->attribute_status(argin));
}

//--------------------------------------------------------
/**
 * method : 		AttributeGetArchiverClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AttributeGetArchiverClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "AttributeGetArchiverClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	return insert((static_cast<HdbConfigurationManager *>(device))->attribute_get_archiver(argin));
}

//--------------------------------------------------------
/**
 * method : 		AttributeSearchClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AttributeSearchClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "AttributeSearchClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	return insert((static_cast<HdbConfigurationManager *>(device))->attribute_search(argin));
}

//--------------------------------------------------------
/**
 * method : 		ArchiverRemoveClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ArchiverRemoveClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "ArchiverRemoveClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	((static_cast<HdbConfigurationManager *>(device))->archiver_remove(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ResetStatisticsClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetStatisticsClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "ResetStatisticsClass::execute(): arrived" << std::endl;
	((static_cast<HdbConfigurationManager *>(device))->reset_statistics());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AttributePauseClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AttributePauseClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "AttributePauseClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	((static_cast<HdbConfigurationManager *>(device))->attribute_pause(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SetAttributeStrategyClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetAttributeStrategyClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "SetAttributeStrategyClass::execute(): arrived" << std::endl;
	const Tango::DevVarStringArray *argin;
	extract(in_any, argin);
	((static_cast<HdbConfigurationManager *>(device))->set_attribute_strategy(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetAttributeStrategyClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetAttributeStrategyClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "GetAttributeStrategyClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	return insert((static_cast<HdbConfigurationManager *>(device))->get_attribute_strategy(argin));
}

//--------------------------------------------------------
/**
 * method : 		SetAttributeTTLClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetAttributeTTLClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "SetAttributeTTLClass::execute(): arrived" << std::endl;
	const Tango::DevVarStringArray *argin;
	extract(in_any, argin);
	((static_cast<HdbConfigurationManager *>(device))->set_attribute_ttl(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetAttributeTTLClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetAttributeTTLClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "GetAttributeTTLClass::execute(): arrived" << std::endl;
	Tango::DevString argin;
	extract(in_any, argin);
	return insert((static_cast<HdbConfigurationManager *>(device))->get_attribute_ttl(argin));
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : HdbConfigurationManagerClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum HdbConfigurationManagerClass::get_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : HdbConfigurationManagerClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum HdbConfigurationManagerClass::get_default_device_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : HdbConfigurationManagerClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum HdbConfigurationManagerClass::get_default_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : HdbConfigurationManagerClass::get_class_property()
 *	Description : Read database to initialize class property data members.
 */
//--------------------------------------------------------
void HdbConfigurationManagerClass::get_class_property()
{
	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::get_class_property_before) ENABLED START -----*/
	
	//	Initialize class property data members
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::get_class_property_before
	//	Read class properties from database.
	cl_prop.push_back(Tango::DbDatum("MaxSearchSize"));
	cl_prop.push_back(Tango::DbDatum("LibConfiguration"));
	
	//	Call database and extract values
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;

	//	Try to extract MaxSearchSize value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  maxSearchSize;
	else
	{
		//	Check default value for MaxSearchSize
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  maxSearchSize;
			cl_prop[i]  <<  maxSearchSize;
		}
	}
	//	Try to extract LibConfiguration value
	if (cl_prop[++i].is_empty()==false)	cl_prop[i]  >>  libConfiguration;
	else
	{
		//	Check default value for LibConfiguration
		def_prop = get_default_class_property(cl_prop[i].name);
		if (def_prop.is_empty()==false)
		{
			def_prop    >>  libConfiguration;
			cl_prop[i]  <<  libConfiguration;
		}
	}
	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::get_class_property_after) ENABLED START -----*/
	
	//	Check class property data members init
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::get_class_property_after

}

//--------------------------------------------------------
/**
 *	Method      : HdbConfigurationManagerClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void HdbConfigurationManagerClass::set_default_property()
{
	std::string	prop_name;
	std::string	prop_desc;
	std::string	prop_def;
	std::vector<std::string>	vect_data;

	//	Set Default Class Properties
	prop_name = "MaxSearchSize";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);
	prop_name = "LibConfiguration";
	prop_desc = "Configuration for the library";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		cl_def_prop.push_back(data);
		add_wiz_class_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_class_prop(prop_name, prop_desc);

	//	Set Default device Properties
	prop_name = "ArchiverList";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MaxSearchSize";
	prop_desc = "Max size of search result";
	prop_def  = "1000";
	vect_data.clear();
	vect_data.push_back("1000");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "LibConfiguration";
	prop_desc = "Configuration for the library";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : HdbConfigurationManagerClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void HdbConfigurationManagerClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	std::string	classname = get_name();
	std::string	header;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	std::string	str_title("Hdb++ configuration manager");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	std::vector<std::string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	std::vector<std::string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : HdbConfigurationManagerClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void HdbConfigurationManagerClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		TANGO_LOG_DEBUG << "Device name : " << (*devlist_ptr)[i].in() << std::endl;
		device_list.push_back(new HdbConfigurationManager(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		HdbConfigurationManager *dev = static_cast<HdbConfigurationManager *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : HdbConfigurationManagerClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void HdbConfigurationManagerClass::attribute_factory(std::vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::attribute_factory_before
	//	Attribute : AttributeOKNumber
	AttributeOKNumberAttrib	*attributeoknumber = new AttributeOKNumberAttrib();
	Tango::UserDefaultAttrProp	attributeoknumber_prop;
	attributeoknumber_prop.set_description("Number of archived attributes not in error");
	//	label	not set for AttributeOKNumber
	//	unit	not set for AttributeOKNumber
	//	standard_unit	not set for AttributeOKNumber
	//	display_unit	not set for AttributeOKNumber
	//	format	not set for AttributeOKNumber
	//	max_value	not set for AttributeOKNumber
	//	min_value	not set for AttributeOKNumber
	//	max_alarm	not set for AttributeOKNumber
	//	min_alarm	not set for AttributeOKNumber
	//	max_warning	not set for AttributeOKNumber
	//	min_warning	not set for AttributeOKNumber
	//	delta_t	not set for AttributeOKNumber
	//	delta_val	not set for AttributeOKNumber
	
	attributeoknumber->set_default_properties(attributeoknumber_prop);
	//	Not Polled
	attributeoknumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributeoknumber);

	//	Attribute : AttributeNokNumber
	AttributeNokNumberAttrib	*attributenoknumber = new AttributeNokNumberAttrib();
	Tango::UserDefaultAttrProp	attributenoknumber_prop;
	attributenoknumber_prop.set_description("Number of archived attributes in error");
	//	label	not set for AttributeNokNumber
	//	unit	not set for AttributeNokNumber
	//	standard_unit	not set for AttributeNokNumber
	//	display_unit	not set for AttributeNokNumber
	//	format	not set for AttributeNokNumber
	//	max_value	not set for AttributeNokNumber
	//	min_value	not set for AttributeNokNumber
	attributenoknumber_prop.set_max_alarm("1");
	//	min_alarm	not set for AttributeNokNumber
	//	max_warning	not set for AttributeNokNumber
	//	min_warning	not set for AttributeNokNumber
	//	delta_t	not set for AttributeNokNumber
	//	delta_val	not set for AttributeNokNumber
	
	attributenoknumber->set_default_properties(attributenoknumber_prop);
	//	Not Polled
	attributenoknumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributenoknumber);

	//	Attribute : AttributePendingNumber
	AttributePendingNumberAttrib	*attributependingnumber = new AttributePendingNumberAttrib();
	Tango::UserDefaultAttrProp	attributependingnumber_prop;
	attributependingnumber_prop.set_description("Number of attributes waiting to be archived");
	//	label	not set for AttributePendingNumber
	//	unit	not set for AttributePendingNumber
	//	standard_unit	not set for AttributePendingNumber
	//	display_unit	not set for AttributePendingNumber
	//	format	not set for AttributePendingNumber
	//	max_value	not set for AttributePendingNumber
	//	min_value	not set for AttributePendingNumber
	//	max_alarm	not set for AttributePendingNumber
	//	min_alarm	not set for AttributePendingNumber
	//	max_warning	not set for AttributePendingNumber
	//	min_warning	not set for AttributePendingNumber
	//	delta_t	not set for AttributePendingNumber
	//	delta_val	not set for AttributePendingNumber
	
	attributependingnumber->set_default_properties(attributependingnumber_prop);
	//	Not Polled
	attributependingnumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributependingnumber);

	//	Attribute : AttributeNumber
	AttributeNumberAttrib	*attributenumber = new AttributeNumberAttrib();
	Tango::UserDefaultAttrProp	attributenumber_prop;
	attributenumber_prop.set_description("Number of configured attributes");
	//	label	not set for AttributeNumber
	//	unit	not set for AttributeNumber
	//	standard_unit	not set for AttributeNumber
	//	display_unit	not set for AttributeNumber
	//	format	not set for AttributeNumber
	//	max_value	not set for AttributeNumber
	//	min_value	not set for AttributeNumber
	//	max_alarm	not set for AttributeNumber
	//	min_alarm	not set for AttributeNumber
	//	max_warning	not set for AttributeNumber
	//	min_warning	not set for AttributeNumber
	//	delta_t	not set for AttributeNumber
	//	delta_val	not set for AttributeNumber
	
	attributenumber->set_default_properties(attributenumber_prop);
	//	Not Polled
	attributenumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributenumber);

	//	Attribute : SetAttributeName
	SetAttributeNameAttrib	*setattributename = new SetAttributeNameAttrib();
	Tango::UserDefaultAttrProp	setattributename_prop;
	//	description	not set for SetAttributeName
	//	label	not set for SetAttributeName
	//	unit	not set for SetAttributeName
	//	standard_unit	not set for SetAttributeName
	//	display_unit	not set for SetAttributeName
	//	format	not set for SetAttributeName
	//	max_value	not set for SetAttributeName
	//	min_value	not set for SetAttributeName
	//	max_alarm	not set for SetAttributeName
	//	min_alarm	not set for SetAttributeName
	//	max_warning	not set for SetAttributeName
	//	min_warning	not set for SetAttributeName
	//	delta_t	not set for SetAttributeName
	//	delta_val	not set for SetAttributeName
	
	setattributename->set_default_properties(setattributename_prop);
	//	Not Polled
	setattributename->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(setattributename);

	//	Attribute : SetPollingPeriod
	SetPollingPeriodAttrib	*setpollingperiod = new SetPollingPeriodAttrib();
	Tango::UserDefaultAttrProp	setpollingperiod_prop;
	//	description	not set for SetPollingPeriod
	//	label	not set for SetPollingPeriod
	//	unit	not set for SetPollingPeriod
	//	standard_unit	not set for SetPollingPeriod
	//	display_unit	not set for SetPollingPeriod
	//	format	not set for SetPollingPeriod
	//	max_value	not set for SetPollingPeriod
	//	min_value	not set for SetPollingPeriod
	//	max_alarm	not set for SetPollingPeriod
	//	min_alarm	not set for SetPollingPeriod
	//	max_warning	not set for SetPollingPeriod
	//	min_warning	not set for SetPollingPeriod
	//	delta_t	not set for SetPollingPeriod
	//	delta_val	not set for SetPollingPeriod
	
	setpollingperiod->set_default_properties(setpollingperiod_prop);
	//	Not Polled
	setpollingperiod->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(setpollingperiod);

	//	Attribute : SetAbsoluteEvent
	SetAbsoluteEventAttrib	*setabsoluteevent = new SetAbsoluteEventAttrib();
	Tango::UserDefaultAttrProp	setabsoluteevent_prop;
	//	description	not set for SetAbsoluteEvent
	//	label	not set for SetAbsoluteEvent
	//	unit	not set for SetAbsoluteEvent
	//	standard_unit	not set for SetAbsoluteEvent
	//	display_unit	not set for SetAbsoluteEvent
	//	format	not set for SetAbsoluteEvent
	//	max_value	not set for SetAbsoluteEvent
	//	min_value	not set for SetAbsoluteEvent
	//	max_alarm	not set for SetAbsoluteEvent
	//	min_alarm	not set for SetAbsoluteEvent
	//	max_warning	not set for SetAbsoluteEvent
	//	min_warning	not set for SetAbsoluteEvent
	//	delta_t	not set for SetAbsoluteEvent
	//	delta_val	not set for SetAbsoluteEvent
	
	setabsoluteevent->set_default_properties(setabsoluteevent_prop);
	//	Not Polled
	setabsoluteevent->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(setabsoluteevent);

	//	Attribute : SetRelativeEvent
	SetRelativeEventAttrib	*setrelativeevent = new SetRelativeEventAttrib();
	Tango::UserDefaultAttrProp	setrelativeevent_prop;
	//	description	not set for SetRelativeEvent
	//	label	not set for SetRelativeEvent
	//	unit	not set for SetRelativeEvent
	//	standard_unit	not set for SetRelativeEvent
	//	display_unit	not set for SetRelativeEvent
	//	format	not set for SetRelativeEvent
	//	max_value	not set for SetRelativeEvent
	//	min_value	not set for SetRelativeEvent
	//	max_alarm	not set for SetRelativeEvent
	//	min_alarm	not set for SetRelativeEvent
	//	max_warning	not set for SetRelativeEvent
	//	min_warning	not set for SetRelativeEvent
	//	delta_t	not set for SetRelativeEvent
	//	delta_val	not set for SetRelativeEvent
	
	setrelativeevent->set_default_properties(setrelativeevent_prop);
	//	Not Polled
	setrelativeevent->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(setrelativeevent);

	//	Attribute : SetPeriodEvent
	SetPeriodEventAttrib	*setperiodevent = new SetPeriodEventAttrib();
	Tango::UserDefaultAttrProp	setperiodevent_prop;
	//	description	not set for SetPeriodEvent
	//	label	not set for SetPeriodEvent
	//	unit	not set for SetPeriodEvent
	//	standard_unit	not set for SetPeriodEvent
	//	display_unit	not set for SetPeriodEvent
	//	format	not set for SetPeriodEvent
	//	max_value	not set for SetPeriodEvent
	//	min_value	not set for SetPeriodEvent
	//	max_alarm	not set for SetPeriodEvent
	//	min_alarm	not set for SetPeriodEvent
	//	max_warning	not set for SetPeriodEvent
	//	min_warning	not set for SetPeriodEvent
	//	delta_t	not set for SetPeriodEvent
	//	delta_val	not set for SetPeriodEvent
	
	setperiodevent->set_default_properties(setperiodevent_prop);
	//	Not Polled
	setperiodevent->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(setperiodevent);

	//	Attribute : SetCodePushedEvent
	SetCodePushedEventAttrib	*setcodepushedevent = new SetCodePushedEventAttrib();
	Tango::UserDefaultAttrProp	setcodepushedevent_prop;
	//	description	not set for SetCodePushedEvent
	//	label	not set for SetCodePushedEvent
	//	unit	not set for SetCodePushedEvent
	//	standard_unit	not set for SetCodePushedEvent
	//	display_unit	not set for SetCodePushedEvent
	//	format	not set for SetCodePushedEvent
	//	max_value	not set for SetCodePushedEvent
	//	min_value	not set for SetCodePushedEvent
	//	max_alarm	not set for SetCodePushedEvent
	//	min_alarm	not set for SetCodePushedEvent
	//	max_warning	not set for SetCodePushedEvent
	//	min_warning	not set for SetCodePushedEvent
	//	delta_t	not set for SetCodePushedEvent
	//	delta_val	not set for SetCodePushedEvent
	
	setcodepushedevent->set_default_properties(setcodepushedevent_prop);
	//	Not Polled
	setcodepushedevent->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(setcodepushedevent);

	//	Attribute : SetArchiver
	SetArchiverAttrib	*setarchiver = new SetArchiverAttrib();
	Tango::UserDefaultAttrProp	setarchiver_prop;
	//	description	not set for SetArchiver
	//	label	not set for SetArchiver
	//	unit	not set for SetArchiver
	//	standard_unit	not set for SetArchiver
	//	display_unit	not set for SetArchiver
	//	format	not set for SetArchiver
	//	max_value	not set for SetArchiver
	//	min_value	not set for SetArchiver
	//	max_alarm	not set for SetArchiver
	//	min_alarm	not set for SetArchiver
	//	max_warning	not set for SetArchiver
	//	min_warning	not set for SetArchiver
	//	delta_t	not set for SetArchiver
	//	delta_val	not set for SetArchiver
	
	setarchiver->set_default_properties(setarchiver_prop);
	//	Not Polled
	setarchiver->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(setarchiver);

	//	Attribute : AttributeMaxStoreTime
	AttributeMaxStoreTimeAttrib	*attributemaxstoretime = new AttributeMaxStoreTimeAttrib();
	Tango::UserDefaultAttrProp	attributemaxstoretime_prop;
	attributemaxstoretime_prop.set_description("Maximum storing time");
	//	label	not set for AttributeMaxStoreTime
	attributemaxstoretime_prop.set_unit("s");
	attributemaxstoretime_prop.set_standard_unit("1");
	attributemaxstoretime_prop.set_display_unit("s");
	//	format	not set for AttributeMaxStoreTime
	//	max_value	not set for AttributeMaxStoreTime
	//	min_value	not set for AttributeMaxStoreTime
	//	max_alarm	not set for AttributeMaxStoreTime
	//	min_alarm	not set for AttributeMaxStoreTime
	//	max_warning	not set for AttributeMaxStoreTime
	//	min_warning	not set for AttributeMaxStoreTime
	//	delta_t	not set for AttributeMaxStoreTime
	//	delta_val	not set for AttributeMaxStoreTime
	
	attributemaxstoretime->set_default_properties(attributemaxstoretime_prop);
	//	Not Polled
	attributemaxstoretime->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributemaxstoretime);

	//	Attribute : AttributeMinStoreTime
	AttributeMinStoreTimeAttrib	*attributeminstoretime = new AttributeMinStoreTimeAttrib();
	Tango::UserDefaultAttrProp	attributeminstoretime_prop;
	attributeminstoretime_prop.set_description("Minimum storing time");
	//	label	not set for AttributeMinStoreTime
	attributeminstoretime_prop.set_unit("s");
	attributeminstoretime_prop.set_standard_unit("1");
	attributeminstoretime_prop.set_display_unit("s");
	//	format	not set for AttributeMinStoreTime
	//	max_value	not set for AttributeMinStoreTime
	//	min_value	not set for AttributeMinStoreTime
	//	max_alarm	not set for AttributeMinStoreTime
	//	min_alarm	not set for AttributeMinStoreTime
	//	max_warning	not set for AttributeMinStoreTime
	//	min_warning	not set for AttributeMinStoreTime
	//	delta_t	not set for AttributeMinStoreTime
	//	delta_val	not set for AttributeMinStoreTime
	
	attributeminstoretime->set_default_properties(attributeminstoretime_prop);
	//	Not Polled
	attributeminstoretime->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributeminstoretime);

	//	Attribute : AttributeMaxProcessingTime
	AttributeMaxProcessingTimeAttrib	*attributemaxprocessingtime = new AttributeMaxProcessingTimeAttrib();
	Tango::UserDefaultAttrProp	attributemaxprocessingtime_prop;
	attributemaxprocessingtime_prop.set_description("Maximum processing (from event reception to storage) time");
	//	label	not set for AttributeMaxProcessingTime
	attributemaxprocessingtime_prop.set_unit("s");
	attributemaxprocessingtime_prop.set_standard_unit("1");
	attributemaxprocessingtime_prop.set_display_unit("s");
	//	format	not set for AttributeMaxProcessingTime
	//	max_value	not set for AttributeMaxProcessingTime
	//	min_value	not set for AttributeMaxProcessingTime
	//	max_alarm	not set for AttributeMaxProcessingTime
	//	min_alarm	not set for AttributeMaxProcessingTime
	//	max_warning	not set for AttributeMaxProcessingTime
	//	min_warning	not set for AttributeMaxProcessingTime
	//	delta_t	not set for AttributeMaxProcessingTime
	//	delta_val	not set for AttributeMaxProcessingTime
	
	attributemaxprocessingtime->set_default_properties(attributemaxprocessingtime_prop);
	//	Not Polled
	attributemaxprocessingtime->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributemaxprocessingtime);

	//	Attribute : AttributeMinProcessingTime
	AttributeMinProcessingTimeAttrib	*attributeminprocessingtime = new AttributeMinProcessingTimeAttrib();
	Tango::UserDefaultAttrProp	attributeminprocessingtime_prop;
	attributeminprocessingtime_prop.set_description("Minimum processing (from event reception to storage) time");
	//	label	not set for AttributeMinProcessingTime
	attributeminprocessingtime_prop.set_unit("s");
	attributeminprocessingtime_prop.set_standard_unit("1");
	attributeminprocessingtime_prop.set_display_unit("s");
	//	format	not set for AttributeMinProcessingTime
	//	max_value	not set for AttributeMinProcessingTime
	//	min_value	not set for AttributeMinProcessingTime
	//	max_alarm	not set for AttributeMinProcessingTime
	//	min_alarm	not set for AttributeMinProcessingTime
	//	max_warning	not set for AttributeMinProcessingTime
	//	min_warning	not set for AttributeMinProcessingTime
	//	delta_t	not set for AttributeMinProcessingTime
	//	delta_val	not set for AttributeMinProcessingTime
	
	attributeminprocessingtime->set_default_properties(attributeminprocessingtime_prop);
	//	Not Polled
	attributeminprocessingtime->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributeminprocessingtime);

	//	Attribute : AttributeRecordFreq
	AttributeRecordFreqAttrib	*attributerecordfreq = new AttributeRecordFreqAttrib();
	Tango::UserDefaultAttrProp	attributerecordfreq_prop;
	attributerecordfreq_prop.set_description("Record frequency");
	//	label	not set for AttributeRecordFreq
	attributerecordfreq_prop.set_unit("ev/period");
	attributerecordfreq_prop.set_standard_unit("1");
	attributerecordfreq_prop.set_display_unit("ev/period");
	//	format	not set for AttributeRecordFreq
	//	max_value	not set for AttributeRecordFreq
	//	min_value	not set for AttributeRecordFreq
	//	max_alarm	not set for AttributeRecordFreq
	//	min_alarm	not set for AttributeRecordFreq
	//	max_warning	not set for AttributeRecordFreq
	//	min_warning	not set for AttributeRecordFreq
	//	delta_t	not set for AttributeRecordFreq
	//	delta_val	not set for AttributeRecordFreq
	
	attributerecordfreq->set_default_properties(attributerecordfreq_prop);
	//	Not Polled
	attributerecordfreq->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributerecordfreq);

	//	Attribute : AttributeFailureFreq
	AttributeFailureFreqAttrib	*attributefailurefreq = new AttributeFailureFreqAttrib();
	Tango::UserDefaultAttrProp	attributefailurefreq_prop;
	attributefailurefreq_prop.set_description("Failure frequency");
	//	label	not set for AttributeFailureFreq
	attributefailurefreq_prop.set_unit("ev/period");
	attributefailurefreq_prop.set_standard_unit("1");
	attributefailurefreq_prop.set_display_unit("ev/period");
	//	format	not set for AttributeFailureFreq
	//	max_value	not set for AttributeFailureFreq
	//	min_value	not set for AttributeFailureFreq
	//	max_alarm	not set for AttributeFailureFreq
	//	min_alarm	not set for AttributeFailureFreq
	//	max_warning	not set for AttributeFailureFreq
	//	min_warning	not set for AttributeFailureFreq
	//	delta_t	not set for AttributeFailureFreq
	//	delta_val	not set for AttributeFailureFreq
	
	attributefailurefreq->set_default_properties(attributefailurefreq_prop);
	//	Not Polled
	attributefailurefreq->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributefailurefreq);

	//	Attribute : AttributeStartedNumber
	AttributeStartedNumberAttrib	*attributestartednumber = new AttributeStartedNumberAttrib();
	Tango::UserDefaultAttrProp	attributestartednumber_prop;
	attributestartednumber_prop.set_description("Number of archived attributes started");
	//	label	not set for AttributeStartedNumber
	//	unit	not set for AttributeStartedNumber
	//	standard_unit	not set for AttributeStartedNumber
	//	display_unit	not set for AttributeStartedNumber
	//	format	not set for AttributeStartedNumber
	//	max_value	not set for AttributeStartedNumber
	//	min_value	not set for AttributeStartedNumber
	//	max_alarm	not set for AttributeStartedNumber
	//	min_alarm	not set for AttributeStartedNumber
	//	max_warning	not set for AttributeStartedNumber
	//	min_warning	not set for AttributeStartedNumber
	//	delta_t	not set for AttributeStartedNumber
	//	delta_val	not set for AttributeStartedNumber
	
	attributestartednumber->set_default_properties(attributestartednumber_prop);
	//	Not Polled
	attributestartednumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributestartednumber);

	//	Attribute : AttributeStoppedNumber
	AttributeStoppedNumberAttrib	*attributestoppednumber = new AttributeStoppedNumberAttrib();
	Tango::UserDefaultAttrProp	attributestoppednumber_prop;
	attributestoppednumber_prop.set_description("Number of archived attributes stopped");
	//	label	not set for AttributeStoppedNumber
	//	unit	not set for AttributeStoppedNumber
	//	standard_unit	not set for AttributeStoppedNumber
	//	display_unit	not set for AttributeStoppedNumber
	//	format	not set for AttributeStoppedNumber
	//	max_value	not set for AttributeStoppedNumber
	//	min_value	not set for AttributeStoppedNumber
	//	max_alarm	not set for AttributeStoppedNumber
	//	min_alarm	not set for AttributeStoppedNumber
	//	max_warning	not set for AttributeStoppedNumber
	//	min_warning	not set for AttributeStoppedNumber
	//	delta_t	not set for AttributeStoppedNumber
	//	delta_val	not set for AttributeStoppedNumber
	
	attributestoppednumber->set_default_properties(attributestoppednumber_prop);
	//	Not Polled
	attributestoppednumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributestoppednumber);

	//	Attribute : AttributeMaxPendingNumber
	AttributeMaxPendingNumberAttrib	*attributemaxpendingnumber = new AttributeMaxPendingNumberAttrib();
	Tango::UserDefaultAttrProp	attributemaxpendingnumber_prop;
	attributemaxpendingnumber_prop.set_description("Max number of attributes waiting to be archived");
	//	label	not set for AttributeMaxPendingNumber
	//	unit	not set for AttributeMaxPendingNumber
	//	standard_unit	not set for AttributeMaxPendingNumber
	//	display_unit	not set for AttributeMaxPendingNumber
	//	format	not set for AttributeMaxPendingNumber
	//	max_value	not set for AttributeMaxPendingNumber
	//	min_value	not set for AttributeMaxPendingNumber
	//	max_alarm	not set for AttributeMaxPendingNumber
	//	min_alarm	not set for AttributeMaxPendingNumber
	//	max_warning	not set for AttributeMaxPendingNumber
	//	min_warning	not set for AttributeMaxPendingNumber
	//	delta_t	not set for AttributeMaxPendingNumber
	//	delta_val	not set for AttributeMaxPendingNumber
	
	attributemaxpendingnumber->set_default_properties(attributemaxpendingnumber_prop);
	//	Not Polled
	attributemaxpendingnumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributemaxpendingnumber);

	//	Attribute : AttributePausedNumber
	AttributePausedNumberAttrib	*attributepausednumber = new AttributePausedNumberAttrib();
	Tango::UserDefaultAttrProp	attributepausednumber_prop;
	attributepausednumber_prop.set_description("Number of archived attributes paused");
	//	label	not set for AttributePausedNumber
	//	unit	not set for AttributePausedNumber
	//	standard_unit	not set for AttributePausedNumber
	//	display_unit	not set for AttributePausedNumber
	//	format	not set for AttributePausedNumber
	//	max_value	not set for AttributePausedNumber
	//	min_value	not set for AttributePausedNumber
	//	max_alarm	not set for AttributePausedNumber
	//	min_alarm	not set for AttributePausedNumber
	//	max_warning	not set for AttributePausedNumber
	//	min_warning	not set for AttributePausedNumber
	//	delta_t	not set for AttributePausedNumber
	//	delta_val	not set for AttributePausedNumber
	
	attributepausednumber->set_default_properties(attributepausednumber_prop);
	//	Not Polled
	attributepausednumber->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(attributepausednumber);

	//	Attribute : SetTTL
	SetTTLAttrib	*setttl = new SetTTLAttrib();
	Tango::UserDefaultAttrProp	setttl_prop;
	setttl_prop.set_description("Time To Live for temporary storage in hours");
	//	label	not set for SetTTL
	setttl_prop.set_unit("hours");
	setttl_prop.set_standard_unit("1");
	setttl_prop.set_display_unit("hours");
	//	format	not set for SetTTL
	//	max_value	not set for SetTTL
	//	min_value	not set for SetTTL
	//	max_alarm	not set for SetTTL
	//	min_alarm	not set for SetTTL
	//	max_warning	not set for SetTTL
	//	min_warning	not set for SetTTL
	//	delta_t	not set for SetTTL
	//	delta_val	not set for SetTTL
	
	setttl->set_default_properties(setttl_prop);
	//	Not Polled
	setttl->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(setttl);

	//	Attribute : SetStrategy
	SetStrategyAttrib	*setstrategy = new SetStrategyAttrib();
	Tango::UserDefaultAttrProp	setstrategy_prop;
	setstrategy_prop.set_description("list of strategies separated with |");
	//	label	not set for SetStrategy
	//	unit	not set for SetStrategy
	//	standard_unit	not set for SetStrategy
	//	display_unit	not set for SetStrategy
	//	format	not set for SetStrategy
	//	max_value	not set for SetStrategy
	//	min_value	not set for SetStrategy
	//	max_alarm	not set for SetStrategy
	//	min_alarm	not set for SetStrategy
	//	max_warning	not set for SetStrategy
	//	min_warning	not set for SetStrategy
	//	delta_t	not set for SetStrategy
	//	delta_val	not set for SetStrategy
	
	setstrategy->set_default_properties(setstrategy_prop);
	//	Not Polled
	setstrategy->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(setstrategy);

	//	Attribute : Context
	ContextAttrib	*context = new ContextAttrib();
	Tango::UserDefaultAttrProp	context_prop;
	//	description	not set for Context
	//	label	not set for Context
	//	unit	not set for Context
	//	standard_unit	not set for Context
	//	display_unit	not set for Context
	//	format	not set for Context
	//	max_value	not set for Context
	//	min_value	not set for Context
	//	max_alarm	not set for Context
	//	min_alarm	not set for Context
	//	max_warning	not set for Context
	//	min_warning	not set for Context
	//	delta_t	not set for Context
	//	delta_val	not set for Context
	
	context->set_default_properties(context_prop);
	//	Not Polled
	context->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(context);

	//	Attribute : ArchiverList
	ArchiverListAttrib	*archiverlist = new ArchiverListAttrib();
	Tango::UserDefaultAttrProp	archiverlist_prop;
	//	description	not set for ArchiverList
	//	label	not set for ArchiverList
	//	unit	not set for ArchiverList
	//	standard_unit	not set for ArchiverList
	//	display_unit	not set for ArchiverList
	//	format	not set for ArchiverList
	//	max_value	not set for ArchiverList
	//	min_value	not set for ArchiverList
	//	max_alarm	not set for ArchiverList
	//	min_alarm	not set for ArchiverList
	//	max_warning	not set for ArchiverList
	//	min_warning	not set for ArchiverList
	//	delta_t	not set for ArchiverList
	//	delta_val	not set for ArchiverList
	
	archiverlist->set_default_properties(archiverlist_prop);
	//	Not Polled
	archiverlist->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(archiverlist);

	//	Attribute : ArchiverStatus
	ArchiverStatusAttrib	*archiverstatus = new ArchiverStatusAttrib();
	Tango::UserDefaultAttrProp	archiverstatus_prop;
	//	description	not set for ArchiverStatus
	//	label	not set for ArchiverStatus
	//	unit	not set for ArchiverStatus
	//	standard_unit	not set for ArchiverStatus
	//	display_unit	not set for ArchiverStatus
	//	format	not set for ArchiverStatus
	//	max_value	not set for ArchiverStatus
	//	min_value	not set for ArchiverStatus
	//	max_alarm	not set for ArchiverStatus
	//	min_alarm	not set for ArchiverStatus
	//	max_warning	not set for ArchiverStatus
	//	min_warning	not set for ArchiverStatus
	//	delta_t	not set for ArchiverStatus
	//	delta_val	not set for ArchiverStatus
	
	archiverstatus->set_default_properties(archiverstatus_prop);
	//	Not Polled
	archiverstatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(archiverstatus);

	//	Attribute : ArchiverStatisticsResetTime
	ArchiverStatisticsResetTimeAttrib	*archiverstatisticsresettime = new ArchiverStatisticsResetTimeAttrib();
	Tango::UserDefaultAttrProp	archiverstatisticsresettime_prop;
	archiverstatisticsresettime_prop.set_description("Seconds elapsed since last statistics reset");
	//	label	not set for ArchiverStatisticsResetTime
	archiverstatisticsresettime_prop.set_unit("s");
	archiverstatisticsresettime_prop.set_standard_unit("1");
	archiverstatisticsresettime_prop.set_display_unit("s");
	//	format	not set for ArchiverStatisticsResetTime
	//	max_value	not set for ArchiverStatisticsResetTime
	//	min_value	not set for ArchiverStatisticsResetTime
	//	max_alarm	not set for ArchiverStatisticsResetTime
	//	min_alarm	not set for ArchiverStatisticsResetTime
	//	max_warning	not set for ArchiverStatisticsResetTime
	//	min_warning	not set for ArchiverStatisticsResetTime
	//	delta_t	not set for ArchiverStatisticsResetTime
	//	delta_val	not set for ArchiverStatisticsResetTime
	
	archiverstatisticsresettime->set_default_properties(archiverstatisticsresettime_prop);
	//	Not Polled
	archiverstatisticsresettime->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(archiverstatisticsresettime);

	//	Attribute : ArchiverContext
	ArchiverContextAttrib	*archivercontext = new ArchiverContextAttrib();
	Tango::UserDefaultAttrProp	archivercontext_prop;
	archivercontext_prop.set_description("Archiver context");
	//	label	not set for ArchiverContext
	archivercontext_prop.set_unit("s");
	archivercontext_prop.set_standard_unit("1");
	archivercontext_prop.set_display_unit("s");
	//	format	not set for ArchiverContext
	//	max_value	not set for ArchiverContext
	//	min_value	not set for ArchiverContext
	//	max_alarm	not set for ArchiverContext
	//	min_alarm	not set for ArchiverContext
	//	max_warning	not set for ArchiverContext
	//	min_warning	not set for ArchiverContext
	//	delta_t	not set for ArchiverContext
	//	delta_val	not set for ArchiverContext
	
	archivercontext->set_default_properties(archivercontext_prop);
	//	Not Polled
	archivercontext->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(archivercontext);

	//	Attribute : ContextsList
	ContextsListAttrib	*contextslist = new ContextsListAttrib();
	Tango::UserDefaultAttrProp	contextslist_prop;
	//	description	not set for ContextsList
	//	label	not set for ContextsList
	//	unit	not set for ContextsList
	//	standard_unit	not set for ContextsList
	//	display_unit	not set for ContextsList
	//	format	not set for ContextsList
	//	max_value	not set for ContextsList
	//	min_value	not set for ContextsList
	//	max_alarm	not set for ContextsList
	//	min_alarm	not set for ContextsList
	//	max_warning	not set for ContextsList
	//	min_warning	not set for ContextsList
	//	delta_t	not set for ContextsList
	//	delta_val	not set for ContextsList
	
	contextslist->set_default_properties(contextslist_prop);
	//	Not Polled
	contextslist->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(contextslist);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : HdbConfigurationManagerClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void HdbConfigurationManagerClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::pipe_factory_before
	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : HdbConfigurationManagerClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void HdbConfigurationManagerClass::command_factory()
{
	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::command_factory_before


	//	Command AttributeAdd
	AttributeAddClass	*pAttributeAddCmd =
		new AttributeAddClass("AttributeAdd",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAttributeAddCmd);

	//	Command AttributeRemove
	AttributeRemoveClass	*pAttributeRemoveCmd =
		new AttributeRemoveClass("AttributeRemove",
			Tango::DEV_STRING, Tango::DEV_VOID,
			"Attribute name",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAttributeRemoveCmd);

	//	Command AttributeStart
	AttributeStartClass	*pAttributeStartCmd =
		new AttributeStartClass("AttributeStart",
			Tango::DEV_STRING, Tango::DEV_VOID,
			"Attribute name",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAttributeStartCmd);

	//	Command AttributeStop
	AttributeStopClass	*pAttributeStopCmd =
		new AttributeStopClass("AttributeStop",
			Tango::DEV_STRING, Tango::DEV_VOID,
			"Attribute name",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAttributeStopCmd);

	//	Command ArchiverAdd
	ArchiverAddClass	*pArchiverAddCmd =
		new ArchiverAddClass("ArchiverAdd",
			Tango::DEV_STRING, Tango::DEV_VOID,
			"Archiver name",
			"",
			Tango::OPERATOR);
	command_list.push_back(pArchiverAddCmd);

	//	Command AttributeAssign
	AttributeAssignClass	*pAttributeAssignCmd =
		new AttributeAssignClass("AttributeAssign",
			Tango::DEVVAR_STRINGARRAY, Tango::DEV_VOID,
			"[0]: Attribute name\n[1]: Archiver name\n[2]: Attribute Strategy\n[3]: Attribute ttl",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAttributeAssignCmd);

	//	Command AttributeStatus
	AttributeStatusClass	*pAttributeStatusCmd =
		new AttributeStatusClass("AttributeStatus",
			Tango::DEV_STRING, Tango::DEV_STRING,
			"The attribute name",
			"The attribute status. TODO: DevString OK?",
			Tango::OPERATOR);
	command_list.push_back(pAttributeStatusCmd);

	//	Command AttributeGetArchiver
	AttributeGetArchiverClass	*pAttributeGetArchiverCmd =
		new AttributeGetArchiverClass("AttributeGetArchiver",
			Tango::DEV_STRING, Tango::DEV_STRING,
			"Attribute name",
			"Archiver name",
			Tango::OPERATOR);
	command_list.push_back(pAttributeGetArchiverCmd);

	//	Command AttributeSearch
	AttributeSearchClass	*pAttributeSearchCmd =
		new AttributeSearchClass("AttributeSearch",
			Tango::DEV_STRING, Tango::DEVVAR_STRINGARRAY,
			"Attribute name or part of it",
			"Attribute list",
			Tango::OPERATOR);
	command_list.push_back(pAttributeSearchCmd);

	//	Command ArchiverRemove
	ArchiverRemoveClass	*pArchiverRemoveCmd =
		new ArchiverRemoveClass("ArchiverRemove",
			Tango::DEV_STRING, Tango::DEV_VOID,
			"Archiver name",
			"",
			Tango::OPERATOR);
	command_list.push_back(pArchiverRemoveCmd);

	//	Command ResetStatistics
	ResetStatisticsClass	*pResetStatisticsCmd =
		new ResetStatisticsClass("ResetStatistics",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetStatisticsCmd);

	//	Command AttributePause
	AttributePauseClass	*pAttributePauseCmd =
		new AttributePauseClass("AttributePause",
			Tango::DEV_STRING, Tango::DEV_VOID,
			"Attribute name",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAttributePauseCmd);

	//	Command SetAttributeStrategy
	SetAttributeStrategyClass	*pSetAttributeStrategyCmd =
		new SetAttributeStrategyClass("SetAttributeStrategy",
			Tango::DEVVAR_STRINGARRAY, Tango::DEV_VOID,
			"Attribute name, strategies",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSetAttributeStrategyCmd);

	//	Command GetAttributeStrategy
	GetAttributeStrategyClass	*pGetAttributeStrategyCmd =
		new GetAttributeStrategyClass("GetAttributeStrategy",
			Tango::DEV_STRING, Tango::DEV_STRING,
			"Attribute name",
			"Strategy",
			Tango::OPERATOR);
	command_list.push_back(pGetAttributeStrategyCmd);

	//	Command SetAttributeTTL
	SetAttributeTTLClass	*pSetAttributeTTLCmd =
		new SetAttributeTTLClass("SetAttributeTTL",
			Tango::DEVVAR_STRINGARRAY, Tango::DEV_VOID,
			"Attribute name, ttl",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSetAttributeTTLCmd);

	//	Command GetAttributeTTL
	GetAttributeTTLClass	*pGetAttributeTTLCmd =
		new GetAttributeTTLClass("GetAttributeTTL",
			Tango::DEV_STRING, Tango::DEV_ULONG,
			"Attribute name",
			"TTL",
			Tango::OPERATOR);
	command_list.push_back(pGetAttributeTTLCmd);

	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		HdbConfigurationManagerClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void HdbConfigurationManagerClass::create_static_attribute_list(std::vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		std::string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	TANGO_LOG_INFO << defaultAttList.size() << " attributes in default list" << std::endl;

	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		HdbConfigurationManagerClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void HdbConfigurationManagerClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, std::vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((std::string)(*devlist_ptr)[i]).c_str());
		HdbConfigurationManager *dev = static_cast<HdbConfigurationManager *> (dev_impl);

		std::vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		std::vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			std::string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			std::vector<std::string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
//				TANGO_LOG_INFO << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << std::endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : HdbConfigurationManagerClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *HdbConfigurationManagerClass::get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname)
{
	std::vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(HdbConfigurationManagerClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	HdbConfigurationManagerClass::Additional Methods
} //	namespace
